jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
Andreas Gampe | 34a8a0f | 2016-07-20 21:09:29 -0700 | [diff] [blame] | 40 | tmp_dir="${TMPDIR}/${test_dir}" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | export JAVA="java" |
Orion Hodson | 64fe3be | 2018-06-15 12:50:22 +0100 | [diff] [blame] | 44 | export JAVAC="javac -g -Xlint:-options -source 1.8 -target 1.8" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 45 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 46 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 47 | export NEED_DEX="true" |
Alan Leung | cf2de16 | 2018-03-30 20:18:20 +0000 | [diff] [blame] | 48 | export USE_D8="true" |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame] | 49 | export USE_DESUGAR="true" |
Ben Gruver | 14fc9db | 2017-04-28 15:30:49 -0700 | [diff] [blame] | 50 | export SMALI_ARGS="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 51 | |
Alan Leung | d5cbc56 | 2018-03-15 14:02:46 -0700 | [diff] [blame] | 52 | # If d8 was not set by the environment variable, assume it is in the path. |
| 53 | if [ -z "$D8" ]; then |
| 54 | export D8="d8" |
| 55 | fi |
| 56 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 57 | # If dx was not set by the environment variable, assume it is in the path. |
| 58 | if [ -z "$DX" ]; then |
Orion Hodson | 64fe3be | 2018-06-15 12:50:22 +0100 | [diff] [blame] | 59 | export DX="d8-compat-dx" |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 60 | fi |
| 61 | |
Orion Hodson | 64fe3be | 2018-06-15 12:50:22 +0100 | [diff] [blame] | 62 | export DEXMERGER="$D8" |
Alan Leung | d5cbc56 | 2018-03-15 14:02:46 -0700 | [diff] [blame] | 63 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 64 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 65 | if [ -z "$JASMIN" ]; then |
| 66 | export JASMIN="jasmin" |
| 67 | fi |
| 68 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 69 | # If smali was not set by the environment variable, assume it is in the path. |
| 70 | if [ -z "$SMALI" ]; then |
| 71 | export SMALI="smali" |
| 72 | fi |
| 73 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 74 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 75 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 76 | export ANDROID_BUILD_TOP=$oldwd |
| 77 | fi |
| 78 | |
Dan Willemsen | 12371e9 | 2017-03-06 17:55:20 -0800 | [diff] [blame] | 79 | # OUT_DIR defaults to out, and may be relative to $ANDROID_BUILD_TOP. |
| 80 | # Convert it to an absolute path, since we cd into the tmp_dir to run the tests. |
| 81 | export OUT_DIR=${OUT_DIR:-out} |
| 82 | if [[ "$OUT_DIR" != /* ]]; then |
| 83 | export OUT_DIR=$ANDROID_BUILD_TOP/$OUT_DIR |
| 84 | fi |
| 85 | |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 86 | # ANDROID_HOST_OUT is not set in a build environment. |
| 87 | if [ -z "$ANDROID_HOST_OUT" ]; then |
Dan Willemsen | 12371e9 | 2017-03-06 17:55:20 -0800 | [diff] [blame] | 88 | export ANDROID_HOST_OUT=${OUT_DIR}/host/linux-x86 |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 89 | fi |
| 90 | |
Alex Light | 680cbf2 | 2018-10-31 11:00:19 -0700 | [diff] [blame] | 91 | host_lib_root=${ANDROID_HOST_OUT} |
| 92 | |
Igor Murashkin | e518193 | 2017-06-15 16:03:50 -0700 | [diff] [blame] | 93 | # Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false. |
Igor Murashkin | d323277 | 2017-06-22 14:54:13 -0700 | [diff] [blame] | 94 | if [ -z "$DESUGAR" ]; then |
Igor Murashkin | e518193 | 2017-06-15 16:03:50 -0700 | [diff] [blame] | 95 | export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh" |
| 96 | fi |
| 97 | |
Igor Murashkin | 271a0f8 | 2017-02-14 21:14:17 +0000 | [diff] [blame] | 98 | # Zipalign is not on the PATH in some configs, auto-detect it. |
| 99 | if [ -z "$ZIPALIGN" ]; then |
| 100 | if which zipalign >/dev/null; then |
| 101 | ZIPALIGN="zipalign"; |
| 102 | else |
| 103 | # TODO: Add a dependency for zipalign in Android.run-test.mk |
| 104 | # once it doesn't depend on libandroidfw (b/35246701) |
| 105 | case "$OSTYPE" in |
| 106 | darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;; |
| 107 | linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;; |
| 108 | *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;; |
| 109 | esac |
| 110 | fi |
| 111 | fi |
| 112 | export ZIPALIGN |
| 113 | |
David Brazdil | 122c663 | 2018-01-24 17:32:49 +0000 | [diff] [blame] | 114 | # If hiddenapi was not set by the environment variable, assume it is in |
| 115 | # ANDROID_HOST_OUT. |
David Brazdil | 11b67b2 | 2018-01-18 16:41:40 +0000 | [diff] [blame] | 116 | if [ -z "$HIDDENAPI" ]; then |
David Brazdil | 122c663 | 2018-01-24 17:32:49 +0000 | [diff] [blame] | 117 | export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi" |
David Brazdil | 11b67b2 | 2018-01-18 16:41:40 +0000 | [diff] [blame] | 118 | fi |
| 119 | |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 120 | chroot= |
| 121 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 122 | info="info.txt" |
| 123 | build="build" |
| 124 | run="run" |
| 125 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 126 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 127 | output="output.txt" |
| 128 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 129 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 130 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 131 | lib="libartd.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 132 | testlib="arttestd" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 133 | run_args=(--quiet) |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 134 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 135 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 136 | quiet="no" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 137 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 138 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 139 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 140 | dev_mode="no" |
Alex Light | 8d94ddd | 2019-12-18 11:13:03 -0800 | [diff] [blame] | 141 | create_runner="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 142 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 143 | debug_mode="no" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 144 | relocate="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 145 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 146 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 147 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 148 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 149 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 150 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 151 | basic_verify="false" |
| 152 | gc_verify="false" |
| 153 | gc_stress="false" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 154 | jvmti_trace_stress="false" |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 155 | jvmti_field_stress="false" |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 156 | jvmti_step_stress="false" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 157 | jvmti_redefine_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 158 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 159 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 160 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 161 | have_image="yes" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 162 | android_root="/system" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 163 | bisection_search="no" |
Martin Stjernholm | 4815e72 | 2019-09-24 16:20:09 +0100 | [diff] [blame] | 164 | timeout="" |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 165 | suspend_timeout="500000" |
Nicolas Geoffray | acc56ac | 2018-10-09 08:45:24 +0100 | [diff] [blame] | 166 | run_optimizing="false" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 167 | |
Alex Light | 20802ca | 2018-12-05 15:36:03 -0800 | [diff] [blame] | 168 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and |
| 169 | # ART output to approximately 128MB. This should be more than sufficient |
| 170 | # for any test while still catching cases of runaway output. |
| 171 | # Set a hard limit to encourage ART developers to increase the ulimit here if |
| 172 | # needed to support a test case rather than resetting the limit in the run |
| 173 | # script for the particular test in question. Adjust this if needed for |
| 174 | # particular configurations. |
| 175 | file_ulimit=128000 |
| 176 | |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 177 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 178 | while true; do |
| 179 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 180 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 181 | DEX_LOCATION=$tmp_dir |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 182 | run_args+=(--host) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 183 | shift |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 184 | elif [ "x$1" = "x--quiet" ]; then |
| 185 | quiet="yes" |
| 186 | shift |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 187 | elif [ "x$1" = "x--use-java-home" ]; then |
| 188 | if [ -n "${JAVA_HOME}" ]; then |
| 189 | export JAVA="${JAVA_HOME}/bin/java" |
| 190 | export JAVAC="${JAVA_HOME}/bin/javac -g" |
| 191 | else |
| 192 | echo "Passed --use-java-home without JAVA_HOME variable set!" |
| 193 | usage="yes" |
| 194 | fi |
| 195 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 196 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 197 | target_mode="no" |
Alex Light | 2c7aaeb | 2017-01-27 14:08:17 -0800 | [diff] [blame] | 198 | DEX_LOCATION="$tmp_dir" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 199 | runtime="jvm" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 200 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 201 | NEED_DEX="false" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 202 | run_args+=(--jvm) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 203 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 204 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 205 | lib="libart.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 206 | testlib="arttest" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 207 | run_args+=(-O) |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 208 | shift |
| 209 | elif [ "x$1" = "x--dalvik" ]; then |
| 210 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 211 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 212 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 213 | elif [ "x$1" = "x--no-image" ]; then |
| 214 | have_image="no" |
| 215 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 216 | elif [ "x$1" = "x--relocate" ]; then |
| 217 | relocate="yes" |
| 218 | shift |
| 219 | elif [ "x$1" = "x--no-relocate" ]; then |
| 220 | relocate="no" |
| 221 | shift |
| 222 | elif [ "x$1" = "x--prebuild" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 223 | run_args+=(--prebuild) |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 224 | prebuild_mode="yes" |
| 225 | shift; |
Mathieu Chartier | dcd56c9 | 2017-11-20 20:30:24 -0800 | [diff] [blame] | 226 | elif [ "x$1" = "x--compact-dex-level" ]; then |
| 227 | option="$1" |
| 228 | shift |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 229 | run_args+=("$option" "$1") |
Mathieu Chartier | dcd56c9 | 2017-11-20 20:30:24 -0800 | [diff] [blame] | 230 | shift; |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 231 | elif [ "x$1" = "x--strip-dex" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 232 | run_args+=(--strip-dex) |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 233 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 234 | elif [ "x$1" = "x--debuggable" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 235 | run_args+=(-Xcompiler-option --debuggable) |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 236 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 237 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 238 | elif [ "x$1" = "x--no-prebuild" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 239 | run_args+=(--no-prebuild) |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 240 | prebuild_mode="no" |
| 241 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 242 | elif [ "x$1" = "x--gcverify" ]; then |
| 243 | basic_verify="true" |
| 244 | gc_verify="true" |
| 245 | shift |
| 246 | elif [ "x$1" = "x--gcstress" ]; then |
| 247 | basic_verify="true" |
| 248 | gc_stress="true" |
| 249 | shift |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 250 | elif [ "x$1" = "x--jvmti-step-stress" ]; then |
| 251 | jvmti_step_stress="true" |
| 252 | shift |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 253 | elif [ "x$1" = "x--jvmti-redefine-stress" ]; then |
| 254 | jvmti_redefine_stress="true" |
| 255 | shift |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 256 | elif [ "x$1" = "x--jvmti-field-stress" ]; then |
| 257 | jvmti_field_stress="true" |
| 258 | shift |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 259 | elif [ "x$1" = "x--jvmti-trace-stress" ]; then |
| 260 | jvmti_trace_stress="true" |
Alex Light | 8f2c6d4 | 2017-04-10 16:27:35 -0700 | [diff] [blame] | 261 | shift |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 262 | elif [ "x$1" = "x--suspend-timeout" ]; then |
| 263 | shift |
| 264 | suspend_timeout="$1" |
| 265 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 266 | elif [ "x$1" = "x--image" ]; then |
| 267 | shift |
| 268 | image="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 269 | run_args+=(--image "$image") |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 270 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 271 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 272 | shift |
| 273 | option="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 274 | run_args+=(-Xcompiler-option "$option") |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 275 | shift |
Orion Hodson | e1fb77f | 2017-02-27 13:57:18 +0000 | [diff] [blame] | 276 | elif [ "x$1" = "x--build-option" ]; then |
| 277 | shift |
| 278 | option="$1" |
| 279 | build_args="${build_args} $option" |
| 280 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 281 | elif [ "x$1" = "x--runtime-option" ]; then |
| 282 | shift |
| 283 | option="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 284 | run_args+=(--runtime-option "$option") |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 285 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 286 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 287 | shift |
| 288 | gdb_arg="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 289 | run_args+=(--gdb-arg "$gdb_arg") |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 290 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 291 | elif [ "x$1" = "x--debug" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 292 | run_args+=(--debug) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 293 | shift |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 294 | elif [ "x$1" = "x--debug-wrap-agent" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 295 | run_args+=(--debug-wrap-agent) |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 296 | shift |
Alex Light | 0e151e7 | 2017-10-25 10:50:35 -0700 | [diff] [blame] | 297 | elif [ "x$1" = "x--with-agent" ]; then |
| 298 | shift |
| 299 | option="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 300 | run_args+=(--with-agent "$1") |
Alex Light | 0e151e7 | 2017-10-25 10:50:35 -0700 | [diff] [blame] | 301 | shift |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 302 | elif [ "x$1" = "x--debug-agent" ]; then |
| 303 | shift |
| 304 | option="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 305 | run_args+=(--debug-agent "$1") |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 306 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 307 | elif [ "x$1" = "x--gdb" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 308 | run_args+=(--gdb) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 309 | dev_mode="yes" |
| 310 | shift |
Alex Light | e4b4a18 | 2019-02-12 14:19:49 -0800 | [diff] [blame] | 311 | elif [ "x$1" = "x--gdbserver-bin" ]; then |
| 312 | shift |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 313 | run_args+=(--gdbserver-bin "$1") |
Alex Light | e4b4a18 | 2019-02-12 14:19:49 -0800 | [diff] [blame] | 314 | shift |
| 315 | elif [ "x$1" = "x--gdbserver-port" ]; then |
| 316 | shift |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 317 | run_args+=(--gdbserver-port "$1") |
Alex Light | e4b4a18 | 2019-02-12 14:19:49 -0800 | [diff] [blame] | 318 | shift |
| 319 | elif [ "x$1" = "x--gdbserver" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 320 | run_args+=(--gdbserver) |
Alex Light | e4b4a18 | 2019-02-12 14:19:49 -0800 | [diff] [blame] | 321 | dev_mode="yes" |
| 322 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 323 | elif [ "x$1" = "x--strace" ]; then |
| 324 | strace="yes" |
Martin Stjernholm | 4815e72 | 2019-09-24 16:20:09 +0100 | [diff] [blame] | 325 | run_args+=(--invoke-with strace --invoke-with -o --invoke-with "$tmp_dir/$strace_output") |
| 326 | timeout="${timeout:-1800}" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 327 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 328 | elif [ "x$1" = "x--zygote" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 329 | run_args+=(--zygote) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 330 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 331 | elif [ "x$1" = "x--interpreter" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 332 | run_args+=(--interpreter) |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 333 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 334 | elif [ "x$1" = "x--jit" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 335 | run_args+=(--jit) |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 336 | shift |
Nicolas Geoffray | acc56ac | 2018-10-09 08:45:24 +0100 | [diff] [blame] | 337 | elif [ "x$1" = "x--baseline" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 338 | run_args+=(--baseline) |
Nicolas Geoffray | acc56ac | 2018-10-09 08:45:24 +0100 | [diff] [blame] | 339 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 340 | elif [ "x$1" = "x--optimizing" ]; then |
Nicolas Geoffray | acc56ac | 2018-10-09 08:45:24 +0100 | [diff] [blame] | 341 | run_optimizing="true" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 342 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 343 | elif [ "x$1" = "x--no-verify" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 344 | run_args+=(--no-verify) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 345 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 346 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 347 | run_args+=(--verify-soft-fail) |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 348 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 349 | elif [ "x$1" = "x--no-optimize" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 350 | run_args+=(--no-optimize) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 351 | shift |
| 352 | elif [ "x$1" = "x--no-precise" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 353 | run_args+=(--no-precise) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 354 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 355 | elif [ "x$1" = "x--invoke-with" ]; then |
| 356 | shift |
| 357 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 358 | if [ "x$what" = "x" ]; then |
| 359 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 360 | usage="yes" |
| 361 | break |
| 362 | fi |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 363 | run_args+=(--invoke-with "${what}") |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 364 | shift |
Alex Light | 8d94ddd | 2019-12-18 11:13:03 -0800 | [diff] [blame] | 365 | elif [ "x$1" = "x--create-runner" ]; then |
| 366 | run_args+=(--create-runner --dry-run) |
| 367 | dev_mode="yes" |
| 368 | never_clean="yes" |
| 369 | create_runner="yes" |
| 370 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 371 | elif [ "x$1" = "x--dev" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 372 | run_args+=(--dev) |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 373 | dev_mode="yes" |
| 374 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 375 | elif [ "x$1" = "x--build-only" ]; then |
| 376 | build_only="yes" |
| 377 | shift |
| 378 | elif [ "x$1" = "x--output-path" ]; then |
| 379 | shift |
| 380 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 381 | if [ "x$tmp_dir" = "x" ]; then |
| 382 | echo "$0 missing argument to --output-path" 1>&2 |
| 383 | usage="yes" |
| 384 | break |
| 385 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 386 | shift |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 387 | elif [ "x$1" = "x--chroot" ]; then |
| 388 | shift |
| 389 | if [ "x$1" = "x" ]; then |
| 390 | echo "$0 missing argument to --chroot" 1>&2 |
| 391 | usage="yes" |
| 392 | break |
| 393 | fi |
| 394 | chroot="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 395 | run_args+=(--chroot "$1") |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 396 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 397 | elif [ "x$1" = "x--android-root" ]; then |
| 398 | shift |
| 399 | if [ "x$1" = "x" ]; then |
| 400 | echo "$0 missing argument to --android-root" 1>&2 |
| 401 | usage="yes" |
| 402 | break |
| 403 | fi |
| 404 | android_root="$1" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 405 | run_args+=(--android-root "$1") |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 406 | shift |
Martin Stjernholm | e58624f | 2019-09-20 15:53:40 +0100 | [diff] [blame] | 407 | elif [ "x$1" = "x--android-art-root" ]; then |
Roland Levillain | 2807614 | 2019-01-10 16:39:25 +0000 | [diff] [blame] | 408 | shift |
| 409 | if [ "x$1" = "x" ]; then |
Martin Stjernholm | e58624f | 2019-09-20 15:53:40 +0100 | [diff] [blame] | 410 | echo "$0 missing argument to --android-art-root" 1>&2 |
Roland Levillain | 2807614 | 2019-01-10 16:39:25 +0000 | [diff] [blame] | 411 | usage="yes" |
| 412 | break |
| 413 | fi |
Martin Stjernholm | e58624f | 2019-09-20 15:53:40 +0100 | [diff] [blame] | 414 | run_args+=(--android-art-root "$1") |
Roland Levillain | 2807614 | 2019-01-10 16:39:25 +0000 | [diff] [blame] | 415 | shift |
Roland Levillain | 90b3457 | 2019-06-14 15:23:15 +0100 | [diff] [blame] | 416 | elif [ "x$1" = "x--android-tzdata-root" ]; then |
| 417 | shift |
| 418 | if [ "x$1" = "x" ]; then |
| 419 | echo "$0 missing argument to --android-tzdata-root" 1>&2 |
| 420 | usage="yes" |
| 421 | break |
| 422 | fi |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 423 | run_args+=(--android-tzdata-root "$1") |
Roland Levillain | 90b3457 | 2019-06-14 15:23:15 +0100 | [diff] [blame] | 424 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 425 | elif [ "x$1" = "x--update" ]; then |
| 426 | update_mode="yes" |
| 427 | shift |
| 428 | elif [ "x$1" = "x--help" ]; then |
| 429 | usage="yes" |
| 430 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 431 | elif [ "x$1" = "x--64" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 432 | run_args+=(--64) |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 433 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 434 | shift |
Alex Light | 680cbf2 | 2018-10-31 11:00:19 -0700 | [diff] [blame] | 435 | elif [ "x$1" = "x--bionic" ]; then |
| 436 | # soong linux_bionic builds are 64bit only. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 437 | run_args+=(--bionic --host --64) |
Alex Light | 680cbf2 | 2018-10-31 11:00:19 -0700 | [diff] [blame] | 438 | suffix64="64" |
| 439 | target_mode="no" |
| 440 | DEX_LOCATION=$tmp_dir |
| 441 | host_lib_root=$OUT_DIR/soong/host/linux_bionic-x86 |
| 442 | shift |
Alex Light | 6f342dd | 2019-03-27 17:15:42 +0000 | [diff] [blame] | 443 | elif [ "x$1" = "x--runtime-extracted-zipapex" ]; then |
| 444 | shift |
| 445 | # TODO Should we allow the java.library.path to search the zipapex too? |
| 446 | # Not needed at the moment and adding it will be complicated so for now |
| 447 | # we'll ignore this. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 448 | run_args+=(--host --runtime-extracted-zipapex "$1") |
Alex Light | 6f342dd | 2019-03-27 17:15:42 +0000 | [diff] [blame] | 449 | target_mode="no" |
| 450 | DEX_LOCATION=$tmp_dir |
| 451 | shift |
Alex Light | 20802ca | 2018-12-05 15:36:03 -0800 | [diff] [blame] | 452 | elif [ "x$1" = "x--runtime-zipapex" ]; then |
| 453 | shift |
| 454 | # TODO Should we allow the java.library.path to search the zipapex too? |
| 455 | # Not needed at the moment and adding it will be complicated so for now |
| 456 | # we'll ignore this. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 457 | run_args+=(--host --runtime-zipapex "$1") |
Alex Light | 20802ca | 2018-12-05 15:36:03 -0800 | [diff] [blame] | 458 | target_mode="no" |
| 459 | DEX_LOCATION=$tmp_dir |
| 460 | # apex_payload.zip is quite large we need a high enough ulimit to |
| 461 | # extract it. 512mb should be good enough. |
| 462 | file_ulimit=512000 |
| 463 | shift |
Martin Stjernholm | 4815e72 | 2019-09-24 16:20:09 +0100 | [diff] [blame] | 464 | elif [ "x$1" = "x--timeout" ]; then |
| 465 | shift |
| 466 | if [ "x$1" = "x" ]; then |
| 467 | echo "$0 missing argument to --timeout" 1>&2 |
| 468 | usage="yes" |
| 469 | break |
| 470 | fi |
| 471 | timeout="$1" |
| 472 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 473 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 474 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 475 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 476 | elif [ "x$1" = "x--stream" ]; then |
| 477 | trace_stream="true" |
| 478 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 479 | elif [ "x$1" = "x--always-clean" ]; then |
| 480 | always_clean="yes" |
| 481 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 482 | elif [ "x$1" = "x--never-clean" ]; then |
| 483 | never_clean="yes" |
| 484 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 485 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 486 | run_args+=(--dex2oat-swap) |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 487 | shift |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 488 | elif [ "x$1" = "x--instruction-set-features" ]; then |
| 489 | shift |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 490 | run_args+=(--instruction-set-features "$1") |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 491 | shift |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 492 | elif [ "x$1" = "x--bisection-search" ]; then |
| 493 | bisection_search="yes" |
| 494 | shift |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 495 | elif [ "x$1" = "x--vdex" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 496 | run_args+=(--vdex) |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 497 | shift |
Nicolas Geoffray | baeaa9b | 2018-01-26 14:31:17 +0000 | [diff] [blame] | 498 | elif [ "x$1" = "x--dm" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 499 | run_args+=(--dm) |
Nicolas Geoffray | baeaa9b | 2018-01-26 14:31:17 +0000 | [diff] [blame] | 500 | shift |
Nicolas Geoffray | 7498105 | 2017-01-16 17:54:09 +0000 | [diff] [blame] | 501 | elif [ "x$1" = "x--vdex-filter" ]; then |
| 502 | shift |
| 503 | filter=$1 |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 504 | run_args+=(--vdex-filter "$filter") |
Nicolas Geoffray | 7498105 | 2017-01-16 17:54:09 +0000 | [diff] [blame] | 505 | shift |
Jeff Hao | 002b931 | 2017-03-27 16:23:08 -0700 | [diff] [blame] | 506 | elif [ "x$1" = "x--random-profile" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 507 | run_args+=(--random-profile) |
Jeff Hao | 002b931 | 2017-03-27 16:23:08 -0700 | [diff] [blame] | 508 | shift |
Shubham Ajmera | 981d99c | 2017-08-17 14:11:08 -0700 | [diff] [blame] | 509 | elif [ "x$1" = "x--dex2oat-jobs" ]; then |
| 510 | shift |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 511 | run_args+=(-Xcompiler-option "-j$1") |
Shubham Ajmera | 981d99c | 2017-08-17 14:11:08 -0700 | [diff] [blame] | 512 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 513 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 514 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 515 | usage="yes" |
| 516 | break |
| 517 | else |
| 518 | break |
| 519 | fi |
| 520 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 521 | |
Orion Hodson | 6aa4e0d | 2018-05-25 09:39:16 +0100 | [diff] [blame] | 522 | if [ "$usage" = "no" -a "x$1" = "x" ]; then |
| 523 | echo "missing test to run" 1>&2 |
| 524 | usage="yes" |
| 525 | fi |
| 526 | |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 527 | # The DEX_LOCATION with the chroot prefix, if any. |
| 528 | chroot_dex_location="$chroot$DEX_LOCATION" |
| 529 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 530 | # Allocate file descriptor real_stderr and redirect it to the shell's error |
| 531 | # output (fd 2). |
| 532 | if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then |
| 533 | exec {real_stderr}>&2 |
| 534 | else |
| 535 | # In bash before version 4.1 we need to do a manual search for free file |
| 536 | # descriptors. |
| 537 | FD=3 |
| 538 | while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done |
| 539 | real_stderr=$FD |
| 540 | eval "exec ${real_stderr}>&2" |
| 541 | fi |
| 542 | if [ "$quiet" = "yes" ]; then |
| 543 | # Force the default standard output and error to go to /dev/null so we will |
| 544 | # not print them. |
| 545 | exec 1>/dev/null |
| 546 | exec 2>/dev/null |
| 547 | fi |
| 548 | |
| 549 | function err_echo() { |
| 550 | echo "$@" 1>&${real_stderr} |
| 551 | } |
| 552 | |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 553 | # tmp_dir may be relative, resolve. |
| 554 | # |
| 555 | # Cannot use realpath, as it does not exist on Mac. |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 556 | # Cannot use a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 557 | # Cannot use readlink -m, as it does not exist on Mac. |
| 558 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 559 | noncanonical_tmp_dir=$tmp_dir |
Andreas Gampe | 86459c0 | 2019-08-29 14:01:18 -0700 | [diff] [blame] | 560 | tmp_dir="`cd $oldwd ; python -c "import os; import sys; sys.stdout.write(os.path.realpath('$tmp_dir'))"`" |
| 561 | if [ -z $tmp_dir ] ; then |
| 562 | err_echo "Failed to resolve $tmp_dir" |
| 563 | exit 1 |
| 564 | fi |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 565 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 566 | |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 567 | # Add thread suspend timeout flag |
Narayan Kamath | f86c393 | 2017-01-24 17:40:47 +0000 | [diff] [blame] | 568 | if [ ! "$runtime" = "jvm" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 569 | run_args+=(--runtime-option "-XX:ThreadSuspendTimeout=$suspend_timeout") |
Narayan Kamath | f86c393 | 2017-01-24 17:40:47 +0000 | [diff] [blame] | 570 | fi |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 571 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 572 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 573 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 574 | run_args+=(--runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0) |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 575 | fi |
| 576 | if [ "$gc_verify" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 577 | run_args+=(--runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc) |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 578 | fi |
| 579 | if [ "$gc_stress" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 580 | run_args+=(--gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m) |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 581 | fi |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 582 | if [ "$jvmti_redefine_stress" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 583 | run_args+=(--no-app-image --jvmti-redefine-stress) |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 584 | fi |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 585 | if [ "$jvmti_step_stress" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 586 | run_args+=(--no-app-image --jvmti-step-stress) |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 587 | fi |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 588 | if [ "$jvmti_field_stress" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 589 | run_args+=(--no-app-image --jvmti-field-stress) |
Alex Light | 43e935d | 2017-06-19 15:40:40 -0700 | [diff] [blame] | 590 | fi |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 591 | if [ "$jvmti_trace_stress" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 592 | run_args+=(--no-app-image --jvmti-trace-stress) |
Alex Light | 8f2c6d4 | 2017-04-10 16:27:35 -0700 | [diff] [blame] | 593 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 594 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 595 | run_args+=(--runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000) |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 596 | if [ "$trace_stream" = "true" ]; then |
| 597 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 598 | # the ability to analyze the file and just write to /dev/null. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 599 | run_args+=(--runtime-option -Xmethod-trace-file:/dev/null) |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 600 | # Enable streaming mode. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 601 | run_args+=(--runtime-option -Xmethod-trace-stream) |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 602 | else |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 603 | run_args+=(--runtime-option "-Xmethod-trace-file:${DEX_LOCATION}/trace.bin") |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 604 | fi |
| 605 | elif [ "$trace_stream" = "true" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 606 | err_echo "Cannot use --stream without --trace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 607 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 608 | fi |
Martin Stjernholm | 4815e72 | 2019-09-24 16:20:09 +0100 | [diff] [blame] | 609 | if [ -n "$timeout" ]; then |
| 610 | run_args+=(--timeout "$timeout") |
| 611 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 612 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 613 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 93d6846 | 2018-01-02 11:59:45 +0000 | [diff] [blame] | 614 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 615 | function guess_target_arch_name() { |
Andreas Gampe | d0566d4 | 2018-06-06 09:54:34 -0700 | [diff] [blame] | 616 | # Check whether this is a device with native bridge. Currently this is hardcoded |
| 617 | # to x86 + arm. |
David Srbecky | 928d28e | 2020-04-01 17:50:51 +0100 | [diff] [blame] | 618 | local guess_path=${ANDROID_PRODUCT_OUT}/system/apex/com.android.art.testing/javalib |
| 619 | local x86_arm=`ls ${guess_path} | sort | grep -E '^(arm|x86)$'` |
Andreas Gampe | d0566d4 | 2018-06-06 09:54:34 -0700 | [diff] [blame] | 620 | # Collapse line-breaks into spaces |
| 621 | x86_arm=$(echo $x86_arm) |
| 622 | if [ "x$x86_arm" = "xarm x86" ] ; then |
| 623 | err_echo "Native-bridge configuration detected." |
| 624 | # We only support the main arch for tests. |
| 625 | if [ "x${suffix64}" = "x64" ]; then |
| 626 | target_arch_name="" |
| 627 | else |
| 628 | target_arch_name=x86 |
| 629 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 630 | else |
David Srbecky | 928d28e | 2020-04-01 17:50:51 +0100 | [diff] [blame] | 631 | local grep32bit=`ls ${guess_path} | grep -E '^(arm|x86)$'` |
| 632 | local grep64bit=`ls ${guess_path} | grep -E '^(arm64|x86_64)$'` |
Andreas Gampe | d0566d4 | 2018-06-06 09:54:34 -0700 | [diff] [blame] | 633 | if [ "x${suffix64}" = "x64" ]; then |
| 634 | target_arch_name=${grep64bit} |
| 635 | else |
| 636 | target_arch_name=${grep32bit} |
| 637 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 638 | fi |
| 639 | } |
| 640 | |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 641 | function guess_host_arch_name() { |
| 642 | if [ "x${suffix64}" = "x64" ]; then |
| 643 | host_arch_name="x86_64" |
| 644 | else |
| 645 | host_arch_name="x86" |
| 646 | fi |
| 647 | } |
| 648 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 649 | if [ "$target_mode" = "no" ]; then |
| 650 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 651 | if [ "$prebuild_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 652 | err_echo "--prebuild with --jvm is unsupported" |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 653 | exit 1 |
| 654 | fi |
| 655 | else |
| 656 | # ART/Dalvik host mode. |
| 657 | if [ -n "$chroot" ]; then |
| 658 | err_echo "--chroot with --host is unsupported" |
| 659 | exit 1 |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 660 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 661 | fi |
| 662 | fi |
| 663 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 664 | if [ ! "$runtime" = "jvm" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 665 | run_args+=(--lib "$lib") |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 666 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 667 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 668 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 669 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 93d6846 | 2018-01-02 11:59:45 +0000 | [diff] [blame] | 670 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Victor Chang | 759845f | 2019-08-06 16:04:36 +0100 | [diff] [blame] | 671 | bpath="${framework}/core-icu4j.jar:${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 672 | run_args+=(--boot --runtime-option "-Xbootclasspath:${bpath}") |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 673 | else |
| 674 | true # defaults to using target BOOTCLASSPATH |
| 675 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 676 | elif [ "$runtime" = "art" ]; then |
Ulya Trafimovich | 5439f05 | 2020-07-29 10:03:46 +0100 | [diff] [blame] | 677 | if [ "$target_mode" = "no" ]; then |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 678 | guess_host_arch_name |
Martin Stjernholm | 9fde2db | 2020-10-15 16:03:29 +0100 | [diff] [blame^] | 679 | run_args+=(--boot "${ANDROID_HOST_OUT}/apex/art_boot_images/javalib/boot.art") |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 680 | run_args+=(--runtime-option "-Djava.library.path=${host_lib_root}/lib${suffix64}:${host_lib_root}/nativetest${suffix64}") |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 681 | else |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 682 | guess_target_arch_name |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 683 | run_args+=(--runtime-option "-Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}") |
David Srbecky | 928d28e | 2020-04-01 17:50:51 +0100 | [diff] [blame] | 684 | run_args+=(--boot "/apex/com.android.art/javalib/boot.art") |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 685 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 686 | if [ "$relocate" = "yes" ]; then |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 687 | run_args+=(--relocate) |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 688 | else |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 689 | run_args+=(--no-relocate) |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 690 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 691 | elif [ "$runtime" = "jvm" ]; then |
| 692 | # TODO: Detect whether the host is 32-bit or 64-bit. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 693 | run_args+=(--runtime-option "-Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64") |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 694 | fi |
| 695 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 696 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 697 | if [ "$runtime" != "art" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 698 | err_echo "--no-image is only supported on the art runtime" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 699 | exit 1 |
| 700 | fi |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 701 | run_args+=(--no-image) |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 702 | fi |
| 703 | |
Alex Light | 8d94ddd | 2019-12-18 11:13:03 -0800 | [diff] [blame] | 704 | if [ "$create_runner" = "yes" -a "$target_mode" = "yes" ]; then |
| 705 | err_echo "--create-runner does not function for non --host tests" |
| 706 | usage="yes" |
| 707 | fi |
| 708 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 709 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 710 | err_echo "--dev and --update are mutually exclusive" |
| 711 | usage="yes" |
| 712 | fi |
| 713 | |
| 714 | if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then |
| 715 | err_echo "--dev and --quiet are mutually exclusive" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 716 | usage="yes" |
| 717 | fi |
| 718 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 719 | if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then |
| 720 | err_echo "--bisection-search and --prebuild are mutually exclusive" |
| 721 | usage="yes" |
| 722 | fi |
| 723 | |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 724 | # TODO: Chroot-based bisection search is not supported yet (see below); implement it. |
| 725 | if [ "$bisection_search" = "yes" -a -n "$chroot" ]; then |
| 726 | err_echo "--chroot with --bisection-search is unsupported" |
| 727 | exit 1 |
| 728 | fi |
| 729 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 730 | if [ "$usage" = "no" ]; then |
| 731 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 732 | test_dir=`basename "$oldwd"` |
| 733 | else |
| 734 | test_dir="$1" |
| 735 | fi |
| 736 | |
| 737 | if [ '!' -d "$test_dir" ]; then |
| 738 | td2=`echo ${test_dir}-*` |
| 739 | if [ '!' -d "$td2" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 740 | err_echo "${test_dir}: no such test directory" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 741 | usage="yes" |
| 742 | fi |
| 743 | test_dir="$td2" |
| 744 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 745 | # Shift to get rid of the test name argument. The rest of the arguments |
| 746 | # will get passed to the test run. |
| 747 | shift |
| 748 | fi |
| 749 | |
| 750 | if [ "$usage" = "yes" ]; then |
| 751 | prog=`basename $prog` |
| 752 | ( |
| 753 | echo "usage:" |
| 754 | echo " $prog --help Print this message." |
| 755 | echo " $prog [options] [test-name] Run test normally." |
| 756 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 757 | "(dumps to stdout)." |
Alex Light | 8d94ddd | 2019-12-18 11:13:03 -0800 | [diff] [blame] | 758 | echo " $prog --create-runner [options] [test-name]" |
| 759 | echo " Creates a runner script for use with other " \ |
| 760 | "tools (e.g. parallel_run.py)." |
| 761 | echo " The script will only run the test portion, and " \ |
| 762 | "share oat and dex files." |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 763 | echo " $prog --update [options] [test-name] Update mode" \ |
| 764 | "(replaces expected.txt)." |
| 765 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 766 | "current directory." |
| 767 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 768 | echo " -O Run non-debug rather than debug build (off by default)." |
| 769 | echo " -Xcompiler-option Pass an option to the compiler." |
Orion Hodson | e1fb77f | 2017-02-27 13:57:18 +0000 | [diff] [blame] | 770 | echo " --build-option Pass an option to the build script." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 771 | echo " --runtime-option Pass an option to the runtime." |
Mathieu Chartier | dcd56c9 | 2017-11-20 20:30:24 -0800 | [diff] [blame] | 772 | echo " --compact-dex-level Specify a compact dex level to the compiler." |
Alex Light | c281ba5 | 2017-10-11 11:35:55 -0700 | [diff] [blame] | 773 | echo " --debug Wait for the default debugger to attach." |
| 774 | echo " --debug-agent <agent-path>" |
| 775 | echo " Wait for the given debugger agent to attach. Currently" |
| 776 | echo " only supported on host." |
| 777 | echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props" |
| 778 | echo " to load the debugger agent specified by --debug-agent." |
Alex Light | 0e151e7 | 2017-10-25 10:50:35 -0700 | [diff] [blame] | 779 | echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 780 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 781 | echo " --gdb Run under gdb; incompatible with some tests." |
Alex Light | e4b4a18 | 2019-02-12 14:19:49 -0800 | [diff] [blame] | 782 | echo " --gdbserver Start gdbserver (defaults to port :5039)." |
| 783 | echo " --gdbserver-port <port>" |
| 784 | echo " Start gdbserver with the given COMM (see man gdbserver)." |
| 785 | echo " --gdbserver-bin <binary>" |
| 786 | echo " Use the given binary as gdbserver." |
| 787 | echo " --gdb-arg Pass an option to gdb or gdbserver." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 788 | echo " --build-only Build test files only (off by default)." |
| 789 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 790 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 791 | echo " --optimizing Enable optimizing compiler (default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 792 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 793 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 794 | echo " Verification is enabled if neither --no-verify" |
| 795 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 796 | echo " --no-optimize Turn off optimization (on by default)." |
| 797 | echo " --no-precise Turn off precise GC (on by default)." |
| 798 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 799 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 800 | echo " other runtime options are ignored." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 801 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 802 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 803 | echo " the test." |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 804 | echo " --strip-dex Strip the dex files before starting test." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 805 | echo " --relocate Force the use of relocating in the test, making" |
| 806 | echo " the image and oat files be relocated to a random" |
Nicolas Geoffray | 94e25db | 2017-01-27 14:54:28 +0000 | [diff] [blame] | 807 | echo " address before running." |
| 808 | echo " --no-relocate Force the use of no relocating in the test. (default)" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 809 | echo " --image Run the test using a precompiled boot image. (default)" |
| 810 | echo " --no-image Run the test without a precompiled boot image." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 811 | echo " --host Use the host-mode virtual machine." |
| 812 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 813 | echo " --dalvik Use Dalvik (off by default)." |
| 814 | echo " --jvm Use a host-local RI virtual machine." |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 815 | echo " --use-java-home Use the JAVA_HOME environment variable" |
| 816 | echo " to find the java compiler and runtime" |
| 817 | echo " (if applicable) to run the test with." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 818 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 819 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 820 | echo " --64 Run the test in 64-bit mode" |
Alex Light | 680cbf2 | 2018-10-31 11:00:19 -0700 | [diff] [blame] | 821 | echo " --bionic Use the (host, 64-bit only) linux_bionic libc runtime" |
Alex Light | 20802ca | 2018-12-05 15:36:03 -0800 | [diff] [blame] | 822 | echo " --runtime-zipapex [file]" |
| 823 | echo " Use the given zipapex file to provide runtime binaries" |
Alex Light | 6f342dd | 2019-03-27 17:15:42 +0000 | [diff] [blame] | 824 | echo " --runtime-extracted-zipapex [dir]" |
| 825 | echo " Use the given extracted zipapex directory to provide" |
| 826 | echo " runtime binaries" |
Martin Stjernholm | 4815e72 | 2019-09-24 16:20:09 +0100 | [diff] [blame] | 827 | echo " --timeout n Test timeout in seconds" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 828 | echo " --trace Run with method tracing" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 829 | echo " --strace Run with syscall tracing from strace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 830 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 831 | echo " --gcstress Run with gc stress testing" |
| 832 | echo " --gcverify Run with gc verification" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 833 | echo " --jvmti-trace-stress Run with jvmti method tracing stress testing" |
Alex Light | c38c369 | 2017-06-27 15:45:14 -0700 | [diff] [blame] | 834 | echo " --jvmti-step-stress Run with jvmti single step stress testing" |
Alex Light | b7edcda | 2017-04-27 13:20:31 -0700 | [diff] [blame] | 835 | echo " --jvmti-redefine-stress" |
| 836 | echo " Run with jvmti method redefinition stress testing" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 837 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 838 | echo " --never-clean Keep the test files even if the test succeeds." |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 839 | echo " --chroot [newroot] Run with root directory set to newroot." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 840 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Victor Chang | 6461124 | 2019-07-05 16:32:41 +0100 | [diff] [blame] | 841 | echo " --android-i18n-root [path]" |
| 842 | echo " The path on target for the i18n module root." |
| 843 | echo " (/apex/com.android.i18n by default)." |
Martin Stjernholm | e58624f | 2019-09-20 15:53:40 +0100 | [diff] [blame] | 844 | echo " --android-art-root [path]" |
| 845 | echo " The path on target for the ART module root." |
Martin Stjernholm | d6be5da | 2019-07-16 17:14:46 +0100 | [diff] [blame] | 846 | echo " (/apex/com.android.art by default)." |
Roland Levillain | 90b3457 | 2019-06-14 15:23:15 +0100 | [diff] [blame] | 847 | echo " --android-tzdata-root [path]" |
| 848 | echo " The path on target for the Android Time Zone Data root." |
| 849 | echo " (/apex/com.android.tzdata by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 850 | echo " --dex2oat-swap Use a dex2oat swap file." |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 851 | echo " --instruction-set-features [string]" |
| 852 | echo " Set instruction-set-features for compilation." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 853 | echo " --quiet Don't print anything except failure messages" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 854 | echo " --bisection-search Perform bisection bug search." |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 855 | echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild." |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 856 | echo " --suspend-timeout Change thread suspend timeout ms (default 500000)." |
Shubham Ajmera | 981d99c | 2017-08-17 14:11:08 -0700 | [diff] [blame] | 857 | echo " --dex2oat-jobs Number of dex2oat jobs." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 858 | ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set. |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 859 | exit 1 |
| 860 | fi |
| 861 | |
| 862 | cd "$test_dir" |
| 863 | test_dir=`pwd` |
| 864 | |
| 865 | td_info="${test_dir}/${info}" |
| 866 | td_expected="${test_dir}/${expected}" |
| 867 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 868 | if [ ! -r $td_info ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 869 | err_echo "${test_dir}: missing file $td_info" |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 870 | exit 1 |
| 871 | fi |
| 872 | |
| 873 | if [ ! -r $td_expected ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 874 | err_echo "${test_dir}: missing file $td_expected" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 875 | exit 1 |
| 876 | fi |
| 877 | |
| 878 | # copy the test to a temp dir and run it |
| 879 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 880 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 881 | |
| 882 | rm -rf "$tmp_dir" |
Alex Light | 0aa7a5a | 2018-10-10 15:58:14 +0000 | [diff] [blame] | 883 | cp -LRp "$test_dir" "$tmp_dir" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 884 | cd "$tmp_dir" |
| 885 | |
| 886 | if [ '!' -r "$build" ]; then |
| 887 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 888 | else |
| 889 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 890 | fi |
| 891 | |
| 892 | if [ '!' -r "$run" ]; then |
| 893 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 894 | else |
| 895 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 896 | fi |
| 897 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 898 | if [ '!' -r "$check_cmd" ]; then |
| 899 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 900 | else |
| 901 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 902 | fi |
| 903 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 904 | chmod 755 "$build" |
| 905 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 906 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 907 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 908 | export TEST_NAME=`basename ${test_dir}` |
| 909 | |
Nicolas Geoffray | 1949baf | 2017-10-17 12:14:53 +0000 | [diff] [blame] | 910 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 911 | # Checker when compiled with Optimizing on host. |
| 912 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
Nicolas Geoffray | 8c41a0b | 2020-02-06 16:52:11 +0000 | [diff] [blame] | 913 | if [ "$runtime" = "art" -a "$run_optimizing" = "true" ]; then |
Nicolas Geoffray | 1949baf | 2017-10-17 12:14:53 +0000 | [diff] [blame] | 914 | # In no-prebuild or no-image mode, the compiler only quickens so disable the checker. |
| 915 | if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then |
| 916 | run_checker="yes" |
| 917 | |
Ulya Trafimovich | 5439f05 | 2020-07-29 10:03:46 +0100 | [diff] [blame] | 918 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 1949baf | 2017-10-17 12:14:53 +0000 | [diff] [blame] | 919 | cfg_output_dir="$tmp_dir" |
| 920 | checker_args="--arch=${host_arch_name^^}" |
| 921 | else |
| 922 | cfg_output_dir="$DEX_LOCATION" |
| 923 | checker_args="--arch=${target_arch_name^^}" |
| 924 | fi |
| 925 | |
| 926 | if [ "$debuggable" = "yes" ]; then |
| 927 | checker_args="$checker_args --debuggable" |
| 928 | fi |
| 929 | |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 930 | run_args+=(-Xcompiler-option "--dump-cfg=$cfg_output_dir/$cfg_output" -Xcompiler-option -j1) |
Daniil Riazanovskiy | bfe8fc8 | 2020-10-05 15:07:15 +0000 | [diff] [blame] | 931 | checker_args="$checker_args --print-cfg" |
Nicolas Geoffray | 1949baf | 2017-10-17 12:14:53 +0000 | [diff] [blame] | 932 | fi |
| 933 | fi |
| 934 | fi |
| 935 | |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 936 | run_args+=(--testlib "${testlib}") |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 937 | |
Alex Light | 20802ca | 2018-12-05 15:36:03 -0800 | [diff] [blame] | 938 | if ! ulimit -f ${file_ulimit}; then |
Richard Uhler | 020c0f3 | 2017-03-14 16:23:17 +0000 | [diff] [blame] | 939 | err_echo "ulimit file size setting failed" |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 940 | fi |
| 941 | |
Igor Murashkin | 2de6e08 | 2018-02-28 15:25:23 -0800 | [diff] [blame] | 942 | # Tell the build script which mode (target, host, jvm) we are building for |
| 943 | # to determine the bootclasspath at build time. |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame] | 944 | if [[ "$target_mode" == "yes" ]]; then |
| 945 | build_args="$build_args --target" |
| 946 | else |
Igor Murashkin | 2de6e08 | 2018-02-28 15:25:23 -0800 | [diff] [blame] | 947 | if [[ $runtime == "jvm" ]]; then |
| 948 | build_args="$build_args --jvm" |
| 949 | else |
| 950 | build_args="$build_args --host" |
| 951 | fi |
Igor Murashkin | 2a33775 | 2017-06-16 14:34:40 +0000 | [diff] [blame] | 952 | fi |
| 953 | |
| 954 | if [[ "$dev_mode" == "yes" ]]; then |
| 955 | build_args="$build_args --dev" |
| 956 | fi |
| 957 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 958 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 959 | good_build="yes" |
| 960 | good_run="yes" |
Alex Light | 77fee87 | 2017-09-05 14:51:49 -0700 | [diff] [blame] | 961 | export TEST_RUNTIME="${runtime}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 962 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 963 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 964 | build_exit="$?" |
| 965 | echo "build exit status: $build_exit" 1>&2 |
| 966 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 967 | echo "${test_dir}: running..." 1>&2 |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 968 | "./${run}" "${run_args[@]}" "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 969 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 970 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 971 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 972 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 973 | if [ "$target_mode" = "yes" ]; then |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 974 | adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 975 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 976 | "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1 |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 977 | checker_exit="$?" |
| 978 | if [ "$checker_exit" = "0" ]; then |
| 979 | good="yes" |
| 980 | fi |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 981 | err_echo "checker exit status: $checker_exit" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 982 | else |
| 983 | good="yes" |
| 984 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 985 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 986 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 987 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 988 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 989 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 990 | build_exit="$?" |
| 991 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 992 | echo "${test_dir}: running..." 1>&2 |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 993 | "./${run}" "${run_args[@]}" "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 994 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 995 | if [ "$target_mode" = "yes" ]; then |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 996 | adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 997 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 998 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 999 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1000 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 1001 | good="yes" |
| 1002 | else |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1003 | cat "$build_output" 1>&${real_stderr} 1>&2 |
| 1004 | err_echo "build exit status: $build_exit" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1005 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 1006 | elif [ "$build_only" = "yes" ]; then |
| 1007 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 1008 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 1009 | build_exit="$?" |
| 1010 | if [ "$build_exit" '!=' '0' ]; then |
| 1011 | cp "$build_output" "$output" |
| 1012 | echo "build exit status: $build_exit" >>"$output" |
| 1013 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 1014 | if [ "$?" '!=' "0" ]; then |
| 1015 | good="no" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1016 | err_echo "BUILD FAILED For ${TEST_NAME}" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 1017 | fi |
| 1018 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 1019 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 1020 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 1021 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1022 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 1023 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1024 | build_exit="$?" |
| 1025 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 1026 | echo "${test_dir}: running..." 1>&2 |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 1027 | "./${run}" "${run_args[@]}" "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 1028 | run_exit="$?" |
| 1029 | if [ "$run_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1030 | err_echo "run exit status: $run_exit" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 1031 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 1032 | elif [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 1033 | if [ "$target_mode" = "yes" ]; then |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1034 | adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 1035 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 1036 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 1037 | checker_exit="$?" |
| 1038 | if [ "$checker_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1039 | err_echo "checker exit status: $checker_exit" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 1040 | good_run="no" |
| 1041 | else |
| 1042 | good_run="yes" |
| 1043 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 1044 | else |
| 1045 | good_run="yes" |
| 1046 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1047 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 1048 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1049 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 1050 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 1051 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 1052 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 1053 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 1054 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 1055 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 1056 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 1057 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1058 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 1059 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1060 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 1061 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 1062 | # output == expected |
| 1063 | good="yes" |
| 1064 | echo "${test_dir}: succeeded!" 1>&2 |
| 1065 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1066 | fi |
| 1067 | fi |
| 1068 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1069 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1070 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1071 | echo "${test_dir}: FAILED!" |
| 1072 | echo ' ' |
| 1073 | echo '#################### info' |
| 1074 | cat "${td_info}" | sed 's/^/# /g' |
| 1075 | echo '#################### diffs' |
Nicolas Geoffray | 30a11eb | 2020-01-28 16:04:01 +0000 | [diff] [blame] | 1076 | if [ "$run_checker" == "yes" ]; then |
| 1077 | # Checker failures dump the whole CFG, so we output the whole diff. |
| 1078 | diff --strip-trailing-cr -u "$expected" "$output" |
| 1079 | else |
Hans Boehm | 80dc7dc | 2020-03-10 15:56:42 -0700 | [diff] [blame] | 1080 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 10000 |
Nicolas Geoffray | 30a11eb | 2020-01-28 16:04:01 +0000 | [diff] [blame] | 1081 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1082 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 1083 | if [ "$strace" = "yes" ]; then |
| 1084 | echo '#################### strace output' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 1085 | tail -n 3000 "$tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 1086 | echo '####################' |
| 1087 | fi |
Andreas Gampe | e79ca19 | 2017-07-31 10:30:16 -0700 | [diff] [blame] | 1088 | if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then |
| 1089 | # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The |
| 1090 | # tools used by the given ABI work for both x86 and x86-64. |
| 1091 | echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000 |
| 1092 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1093 | echo ' ' |
| 1094 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1095 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1096 | ) 2>&${real_stderr} 1>&2 |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1097 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1098 | # Attempt bisection only if the test failed. |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1099 | # TODO: Implement support for chroot-based bisection search. |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1100 | if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then |
| 1101 | # Bisecting works by skipping different optimization passes which breaks checker assertions. |
| 1102 | if [ "$run_checker" == "yes" ]; then |
| 1103 | echo "${test_dir}: not bisecting, checker test." 1>&2 |
| 1104 | else |
| 1105 | # Increase file size limit, bisection search can generate large logfiles. |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1106 | echo "${test_dir}: bisecting..." 1>&2 |
| 1107 | cwd=`pwd` |
| 1108 | maybe_device_mode="" |
| 1109 | raw_cmd="" |
| 1110 | if [ "$target_mode" = "yes" ]; then |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1111 | # Produce cmdline.sh in $chroot_dex_location. "$@" is passed as a runtime option |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1112 | # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set |
| 1113 | # to exec in order to preserve pid when calling dalvikvm. This is required |
| 1114 | # for bisection search to correctly retrieve logs from device. |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 1115 | "./${run}" "${run_args[@]}" --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1116 | adb shell chmod u+x "$chroot_dex_location/cmdline.sh" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1117 | maybe_device_mode="--device" |
| 1118 | raw_cmd="$DEX_LOCATION/cmdline.sh" |
| 1119 | else |
Andreas Gampe | 11410de | 2019-07-02 15:53:53 -0700 | [diff] [blame] | 1120 | raw_cmd="$cwd/${run} --external-log-tags "${run_args[@]}" $@" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1121 | fi |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1122 | # TODO: Pass a `--chroot` option to the bisection_search.py script and use it there. |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1123 | $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \ |
| 1124 | $maybe_device_mode \ |
| 1125 | --raw-cmd="$raw_cmd" \ |
| 1126 | --check-script="$cwd/check" \ |
| 1127 | --expected-output="$cwd/expected.txt" \ |
Wojciech Staszkiewicz | 0c88383 | 2016-09-26 17:51:52 -0700 | [diff] [blame] | 1128 | --logfile="$cwd/bisection_log.txt" \ |
Martin Stjernholm | 4815e72 | 2019-09-24 16:20:09 +0100 | [diff] [blame] | 1129 | --timeout=${timeout:-300} |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 1130 | fi |
| 1131 | fi |
| 1132 | |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1133 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 1134 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1135 | cd "$oldwd" |
| 1136 | rm -rf "$tmp_dir" |
| 1137 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1138 | adb shell rm -rf $chroot_dex_location |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1139 | fi |
| 1140 | if [ "$good" = "yes" ]; then |
| 1141 | exit 0 |
| 1142 | fi |
| 1143 | fi |
| 1144 | |
| 1145 | |
| 1146 | ( |
| 1147 | if [ "$always_clean" = "yes" ]; then |
| 1148 | echo "${TEST_NAME} files deleted from host " |
| 1149 | if [ "$target_mode" == "yes" ]; then |
| 1150 | echo "and from target" |
| 1151 | fi |
| 1152 | else |
| 1153 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 1154 | if [ "$target_mode" == "yes" ]; then |
Roland Levillain | 76cfe61 | 2017-10-30 13:14:28 +0000 | [diff] [blame] | 1155 | echo "and in ${chroot_dex_location} on target" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 1156 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 1157 | fi |
| 1158 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 1159 | ) 2>&${real_stderr} 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1160 | |
Alex Light | 6a870fa | 2016-05-31 16:36:19 -0700 | [diff] [blame] | 1161 | if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then |
| 1162 | exit 0 |
| 1163 | else |
| 1164 | exit 1 |
| 1165 | fi |